class Editor.EditorModule.DockModule.ElementBoard extends Editor.EditorModule.DockModule.Board
  
  initialize: (options) ->
    super(options)
    @element = options.element
  
  dom_id: () ->
    super() + '-' + @element.cid  # use tab index
  
class Editor.EditorModule.DockModule.TabModule.ElementBoardLabel extends Editor.EditorModule.DockModule.TabModule.BoardLabel
  
  initialize: (options) ->
    super(options)
    this.$el.attr('data-z', @bay().new_tab.label.z() - 1)
  
  render: () ->
    super()
    this.$el.removeClass('ui-corner-top')
    this.$el.addClass('ui-corner-left z-label')
    this
  
  add_label: () ->
    this.$el.attr('id', @dom_id())
  
  z: () ->
    parseInt(this.$el.attr('data-z'))
  
class Editor.EditorModule.DockModule.TabModule.ElementBoardBody extends Editor.EditorModule.DockModule.TabModule.BoardBody
  
  initialize: (options) ->
    super(options)
    @form = Locmare.Form.factory({
      form_name: @element().item_name(), 
      use_name: 'default' 
      item: @element(), 
      element_form: true, 
      submit: null, 
    })
  
  render: () ->
    @delegateEvents({'activate': 'activate'})
    this.$el.attr('id', @dom_id())
    this.$el.html(@form.render().el)
    this
  
  add_element: (element) ->
    @form.add_element(element)
  
  activate: () ->
    @refresh()
  
  refresh: () ->
    @form.refresh()
  
  element: () ->
    @parent.element
  
