module Editor
  module EditorModule
    module DockModule
      class PriorityBay < BoardBay
        def initialize parent, index, name
          super
          
          self.elements.each_with_index do |element, i| 
            tab = PriorityBoard.new(self, i, element.item_name, element)
            add_tab tab, PriorityBoardLabel.new(tab, element.item_name), 
              PriorityBoardBody.new(tab)
          end
        end
        
        def elements
          self.root_item.scenario_elements
        end
        
        def class_name
          "zsort-box"
        end
        
      end
      
      module TabModule
        class PriorityBayLabel < BayLabel
        end
        
        class PriorityBayBody < BayBody
          def template_file_name
            'priority'
          end
          
        end
        
      end
    end
  end
end
