module LocalManifest
  class LocalManifest
    cattr_accessor :manifest
    attr :list_groups, :profilers, :filers, :forms, :buckets, :module_names
    # call me before load routes.rb
    # routes.rb needs engine_resources manifest in system_resources
    # ex. it's adding license_groups routes
    def initialize local_json
      @module_names = []
      @local_json = local_json || {}
    end
    
    def init
      # managers can't initialize before load  application.rb
      return unless defined? ::Pettanr
      @list_groups = ListGroup.load(self, @local_json, 'list_groups')
      @filers = Filer.load(self, @local_json, 'filers')
      @profilers = Profiler.load(self, @local_json, 'profilers')
      @forms = Form.load(self, @local_json, 'forms')
      @buckets = Bucket.load(self, @local_json, 'buckets')
    end
    
  end
  
  module ModuleMethods
    def manifest
      LocalManifest.manifest
    end
    
    def load local_json
      LocalManifest.manifest = LocalManifest.new local_json
    end
    
  end

  extend ModuleMethods
end

