module Locmare
  module FilerModule
    module BodyModule
      module FileBodyModule
        module FileItemModule
          module CaptionItemColumnModule
            module DefaultModule
              module FaceModule
                class BaseFace
                  attr :default_caption, :face_manifest, :item
                  def initialize default_caption, face_manifest, item
                    @default_caption = default_caption
                    @face_manifest = face_manifest
                    @item = item
                  end
                  
                  def filer
                    @default_caption.filer
                  end
                  
                  def manifest
                    self.filer.manifest
                  end
                  
                  def item_name
                    self.filer.item_name
                  end
                  
                  def template_dir
                    self.filer.template_dir + "caption_face/"
                  end
                  
                  def template_file_name
                    raise "undefined template_file_name\n"
                  end
                  
                  def template_name
                    self.template_dir + self.template_file_name
                  end
                  
                end
                
                class ColumnFace < BaseFace
                  def template_file_name
                    if face.blank?
                      'empty'
                    else
                      'column'
                    end
                  end
                  
                  def face
                    @item.attributes[@face_manifest.column_name]
                  end
                  
                end
                
                class MethodFace < BaseFace
                  def template_file_name
                    if face.blank?
                      'empty'
                    else
                      'column'
                    end
                  end
                  
                  def face
                    @item.__send__ @face_manifest.method_name
                  end
                  
                end
                
                class NoneFace < BaseFace
                  def template_file_name
                    'none'
                  end
                  
                end
                
              end
            end
          end
        end
      end
    end
  end
end
