module Locmare
  module FilerModule
    module BodyModule
      module FileBodyModule
        module FileItemModule
          module DateItemColumnModule
            class Base
              attr :file_item, :date_manifest, :item, :column_name
              
              def initialize file_item, date_manifest, item
                @file_item = file_item
                @date_manifest = date_manifest
                @item = item
                @column_name = 'date'
              end
              
              def filer
                @file_item.filer
              end
              
              def manifest
                self.filer.manifest
              end
              
              def item_name
                self.filer.item_name
              end
              
              def column_template_dir
                self.filer.template_dir + 'item_column/'
              end
              
              def column_template_file_name
                raise "undefined column_template_file_name\n"
              end
              
              def column_template_name
                self.column_template_dir + self.column_template_file_name
              end
              
              def item_template_dir
                self.filer.template_dir + 'date/'
              end
              
              def item_template_file_name
                raise "undefined item_template_file_name\n"
              end
              
              def item_template_name
                self.item_template_dir + self.item_template_file_name
              end
              
            end
            
            class Default < Base
              def column_template_file_name
                'show'
              end
              
              def item_template_file_name
                'default'
              end
              
            end
            
            class None < Base
              def column_template_file_name
                'none'
              end
              
            end
            
          end
        end
      end
    end
  end
end
