module Locmare
  module FormModule
    module FieldModule
      module TagModule
        class SelectTag < Base
          def template_file_name
            'select'
          end
          
          def model_manifest
            ::Manifest.manifest.models[@field.field_manifest.item_name]
          end
          
          def model_attribute_manifest
            self.model_manifest.attributes[@field.field_manifest.column_name]
          end
          
          def select_item_name
            self.model_attribute_manifest.source.select_item_name
          end
          
          def translate?
            self.model_attribute_manifest.source.translate?
          end
          
          def items
            if self.source_by_filter?
              resource_item_name = self.model_attribute_manifest.source.resource_item_name
              resource_action_name = self.model_attribute_manifest.source.resource_action_name
              filter_column_name = self.model_attribute_manifest.source.filter_column_name
              filter_id = self.form.item.attributes[filter_column_name]
              resource_controller_name = ::Manifest.manifest.models[resource_item_name].classify.table_name
              list = Locmare::ListGroup.list(
                resource_controller_name, 
                resource_action_name, 
                self.form.operators, 
                {:id => filter_id, 'page_size' => -1} # no limit
              )
              list.items.map {|i| [i.caption, i.id] }
            else
              ::Manifest.manifest.system_resources.select_items[self.select_item_name]
            end
          end
          
          def source_by_filter?
            case self.model_attribute_manifest.source.type
            when 'filter'
              true
            when 'model', 'magic_number'
              false
            else
              nil
            end
          end
          
        end
        
      end
    end
  end
end
