module Locmare
  module ProfilerModule
    module AssociationModule
      class BelongsTo
        attr :association, :belongs_to_manifest
        def initialize association, belongs_to_manifest
          @association = association
          @belongs_to_manifest = belongs_to_manifest
        end
        
        def item
          self.profiler.item
        end
        
        def parent_model
          @belongs_to_manifest.model
        end
        
        def parent_id
          self.item.attributes[self.model_belongs_to_manifest.id_column]
        end
        
        def filer
          r = nil
          begin
            r = [self.parent_model.show(self.parent_id, self.profiler.operators)]
          rescue ActiveRecord::RecordNotFound, ActiveRecord::Forbidden
            r = []
          end
          ::Locmare::Filer.new(
            self.parent_model.item_name, r, 
            nil, self.profiler.operators
          )
        end
        
        def model_manifest
          ::Manifest.manifest.models[self.profiler.item_name]
        end
        
        def model_belongs_to_manifest
          self.model_manifest.associations.belongs_to[@belongs_to_manifest.item_name]
        end
        
        def profiler
          @association.profiler
        end
        
      end
    end
  end
end
